/**
 * FIGgyTape, a cross platform file system to FIGgyAudio transfer app.
 * Copyright (C) 2014  Julian Skidmore.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Versions
 * ********
 *
 * 0.1.0 Initial Release.
 *
 * Contact
 * *******
 * TheOriginalSnial@Gmail.com
 *
 * Notes:
 * To recompile all the java files:
 * javac start/*.java
 * To run the class files from a folder:
 * java -cp .: start/FIGgyTape
 * To create a Jar file.
 * jar cvmf MANIFEST.MF FIGgyTape.jar start
 * To run the jar file from the command line:
 * java -jar FIGgyTape.jar
 */

/**
 * This example, like all Swing examples, exists in a package:
 * in this case, the "start" package.
 * If you are using an IDE, such as NetBeans, this should work 
 * seamlessly.  If you are compiling and running the examples
 * from the command-line, this may be confusing if you aren't
 * used to using named packages.  In most cases,
 * the quick and dirty solution is to delete or comment out
 * the "package" line from all the source files and the code
 * should work as expected.  For an explanation of how to
 * use the Swing examples as-is from the command line, see
 * http://docs.oracle.com/javase/javatutorials/tutorial/uiswing/start/compile.html#package
 */
package start;

import javax.swing.*;        

/*
 * FIGgyTape.java requires no other files. 
 */
public class FIGgyTape {

    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static void createAndShowGUI() {
        JFrame frame = new JFrame("FIGgyTape");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    	FIGgyTapeFrame mainPane=new FIGgyTapeFrame();
    	mainPane.init(frame);
		mainPane.setOpaque(true);
		frame.setContentPane(mainPane);
        frame.pack();
        frame.setResizable(false);
        frame.setVisible(true);
    }

    public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });
    }
}
