package start;

import java.lang.Exception;
import java.lang.Math;
import java.util.LinkedList;

import javax.swing.*;   
import javax.swing.event.ChangeListener;   
import javax.swing.event.ChangeEvent;   
import java.awt.event.*;
import java.awt.BorderLayout;

import java.awt.Menu;
import java.awt.MenuBar;
import java.awt.MenuItem;
import java.awt.CheckboxMenuItem;
import java.awt.MenuShortcut;
import java.awt.FileDialog;
import java.awt.Dimension;

import java.io.FilenameFilter;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.ByteArrayInputStream;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.InputStream;
import java.io.IOException;

import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioFileFormat;
import javax.sound.sampled.AudioInputStream;

import javax.sound.sampled.Line;
import javax.sound.sampled.LineEvent;
import javax.sound.sampled.LineListener;

public class FIGgyTapeFrame extends JPanel implements ActionListener,
					FilenameFilter, LineListener, ChangeListener {

	private static final long serialVersionUID = 1;
	
	public JFrame root=null;
	
	public JLabel statusLabel=null;
	public JButton butTapeStart=null;
	public JButton butRew=null;
	public JButton butPlay=null;
	public JButton butRec=null;
	public JButton butStop=null;
	public JButton butFwd=null;
	public JButton butTapeEnd=null;
	public JPanel transport=null;
	public JSlider vol = null;
	public JTextArea cliArea=null;
	public String gCliText=new String("cli");
	
	// instances.
	public int fileNum=0;
	public File audioFile;
	public AudioInputStream audioStream;
	public String pwd="";
	public AudioFileFormat audioFormat;
	public AudioFormat toneFormat;
	public int audioFrames;
	public TapePlayer tapePlayer=null;
	public TapeRecorder tapeRecorder=null;
	public float sampleRate=(float)(44100.0/8.0);
	public int sampleShift=2;
	
	
	FileWriter iDebugLog=null;

	
	public static int kLastFile=10;
	
	public MenuBar menuBar=null;
	public Menu menuFile=null;
	public Menu menuSpeed=null;
	public Menu menuTone=null;
	public Menu menuDebug=null;
	public Menu menuSpecial=null;
	public CheckboxMenuItem iDebugLogItem=null;
	
	public String cmdName[] = {
		"cmdTapeStart", "cmdRew", "cmdPlay", "cmdRec", "cmdStop", "cmdFwd", "cmdTapeEnd",
		"cmdNew", "cmdOpen", "cmdRun", "cmdFlash", "cmdUpgrade", "cmdClose", "cmdSave",
		"cmd44Kb", "cmd22Kb", "cmd11Kb", "cmd500b",
		"cmdLeader", "cmdLeaderStart", "cmdLeaderByte", "cmdSaw", "cmdCli", "cmdRecWav",
		"cmdDebugLog",
		"cmdMigrate" ,
		
	};
	
	public final static int  kCmdTapeStart=0;
	public final static int  kCmdTapeRew=1;
	public final static int  kCmdTapePlay=2;
	public final static int  kCmdTapeRec=3;	
	public final static int  kCmdTapeStop=4;
	public final static int  kCmdTapeFwd=5;
	public final static int  kCmdTapeEnd=6;

	public final static int  kCmdFileNew=7;
	public final static int  kCmdFileOpen=8;
	public final static int kCmdFileRun=9;
	public final static int kCmdFileFlash=10;
	public final static int  kCmdFileUpgrade=11;
	public final static int  kCmdFileClose=12;
	public final static int  kCmdFileSave=13;

	public final static int  kCmdSpeed44K=14;
	public final static int  kCmdSpeed22K=15;
	public final static int  kCmdSpeed11K=16;
	public final static int  kCmdSpeed500=17;

	public final static int  kCmdLeader=18;
	public final static int  kCmdLeaderStart=19;
	public final static int  kCmdLeaderByte=20;
	public final static int  kCmdSaw=21;
	public final static int  kCmdCli=22;
	public final static int  kCmdRecWav=23;
	
	public final static int  kCmdDebugLog=24;	
	public final static int  kCmdMigrate=25;	

	public final static int  kMaxCmds=26;

	public boolean accept(File dir, String name) {
		return name.endsWith(".wav") || name.endsWith(".fth") ||
					name.endsWith(".txt") || name.endsWith(".bin") ||
					name.endsWith(".hex");
	}

	public void WavGen(String pwd, String fName) {
		audioFile = new java.io.File(pwd,fName);
		try {
			audioFormat= javax.sound.sampled.AudioSystem.getAudioFileFormat(audioFile) ;
			int audioFrames=audioFormat.getFrameLength();
			audioStream=new AudioInputStream((InputStream)new FileInputStream(audioFile),
											audioFormat.getFormat(), audioFrames);
			tapePlayer=new TapePlayer(audioFormat.getFormat(),audioStream);
		}
		catch(Exception ex) {
			System.out.println("Exception: "+ex);
		}
	}

	public void FileOpen() {
		FileDialog fd=new FileDialog(root,"Open",FileDialog.LOAD);
		fd.setDirectory(pwd);
		fd.setFilenameFilter(this);
		fd.setVisible(true);
		String fName=fd.getFile();
		if(fName!=null) {
			pwd=fd.getDirectory();	// remember it for next time.
			System.out.println("Opened: "+fName);
			if(fName.endsWith(".wav")) {
				WavGen(pwd,fName);
			}
			else if(fName.endsWith(".fth") || fName.endsWith(".txt") || fName.endsWith(".bin"))
				BinGen(pwd,fName);
			
		}
		else
			System.out.println("Open Cancelled");
	}

	public void FileRun() {
		FileDialog fd=new FileDialog(root,"Run",FileDialog.LOAD);
		fd.setDirectory(pwd);
		fd.setFilenameFilter(this);
		fd.setVisible(true);
		String fName=fd.getFile();
		if(fName!=null) {
			pwd=fd.getDirectory();	// remember it for next time.
			System.out.println("Opened: "+fName);
			if(fName.endsWith(".wav")) {
				WavGen(pwd,fName);
			}
			else if(fName.endsWith(".fth") || fName.endsWith(".txt") || fName.endsWith(".bin"))
				RunBinGen(pwd,fName);
			
		}
		else
			System.out.println("Open Cancelled");
	}

	public void FileExtFlash() {
		FileDialog fd=new FileDialog(root,"Load to External Flash",FileDialog.LOAD);
		fd.setDirectory(pwd);
		fd.setFilenameFilter(this);
		fd.setVisible(true);
		String fName=fd.getFile();
		if(fName!=null) {
			pwd=fd.getDirectory();	// remember it for next time.
			System.out.println("Opened: "+fName);
			if(fName.endsWith(".fth") || fName.endsWith(".txt") || fName.endsWith(".bin"))
				loadExtFlash(pwd,fName);
			
		}
		else
			System.out.println("Open Cancelled");
	}

	public void FileUpgrade(boolean migrate) {
		FileDialog fd=new FileDialog(root,(migrate?
				"Upgrade":"Migrate")+" FIGnition Firmware",FileDialog.LOAD);
		fd.setDirectory(pwd);
		fd.setFilenameFilter(this);
		fd.setVisible(true);
		String fName=fd.getFile();
		if(fName!=null) {
			pwd=fd.getDirectory();	// remember it for next time.
			System.out.println("Opened: "+fName);
			if(fName.endsWith("PAL16.bin") || fName.endsWith("NTSC16.bin"))
				loadUpgrade(pwd,fName,migrate);
			
		}
		else
			System.out.println("Open Cancelled");
	}

	public void GenTone(byte[] tone) {
		try {
			toneFormat= new AudioFormat(44100, 16, 2, true, false); 
			tapePlayer=new TapePlayer(toneFormat,tone);
		}
		catch(Exception ex) {
			System.out.println("Exception: "+ex);
		}
	}

	public TapeRecorder GenRecorder(int aRecMode) {
		try {
			toneFormat= new AudioFormat(44100, 16, 2, true, false); 
			tapeRecorder=new TapeRecorder(toneFormat,sampleShift,aRecMode);
			return tapeRecorder;
		}
		catch(Exception ex) {
			System.out.println("Exception: "+ex);
			return null;
		}
	}

	int toneLen=65536; // 44100*4*1;
	void GenToneBit(byte[] tone,int pos, int bitVal) {
		short sample=(short)((bitVal==0)?0x8000:0x7fff);
		tone[4*pos]=(byte)(sample&255);
		tone[4*pos+1]=(byte)(sample>>8);	// left channel?
		tone[4*pos+2]=(byte)(sample&255);
		tone[4*pos+3]=(byte)(sample>>8);	// right channel?
	}
	
	public void GenLeader() {
		byte[] tone=new byte[toneLen];	// 1024 samples worth.
		for(int ix=0;ix<tone.length/4;ix++) {
			GenToneBit(tone,ix,(ix>>(sampleShift+1))&1);
		}
		GenTone(tone);
	}

	public void GenSaw() {
		byte[] tone=new byte[1024];
		for(int ix=0;ix<tone.length;ix++) {
			tone[ix]=(byte)((ix&127)*2-128);
		}
		GenTone(tone);
	}

	public void GenLeaderStart() {
		int samplesPerTrans=1<<sampleShift;
		byte[] tone=new byte[toneLen+2*4*samplesPerTrans];	// 1024 samples worth.
		for(int ix=0;ix<(toneLen/4);ix++) {
			GenToneBit(tone,ix,(ix>>(sampleShift+1))&1);
			if(ix<4*samplesPerTrans)
				System.out.println("LeaderStartA: "+ix+": "+((ix>>sampleShift+1)&1));
		}

		for(int ix=(toneLen/4);ix<(toneLen/4)+2*samplesPerTrans;ix++) {
			GenToneBit(tone,ix,((ix>>sampleShift)&1));
			System.out.println("LeaderStart: "+ix+": "+(((ix>>sampleShift)&1)));
		}
	
		GenTone(tone);
	}


	int GenToneBitMsg(byte[] tone,int pos, int bitVal) {
		for(int ix=0;ix<(1<<sampleShift);ix++)
			GenToneBit(tone,pos+ix,bitVal);
		System.out.print(":"+bitVal);
		return pos+(1<<sampleShift);
	}
	
	public void GenLeaderByte() {
		int samplesPerTrans=1<<sampleShift;
		int bytesPerTrans=4*samplesPerTrans;
		byte[] tone=new byte[toneLen+14*bytesPerTrans];	// 1024 samples worth.
		for(int ix=0;ix<(toneLen/4);ix++) {
			GenToneBit(tone,ix,(ix>>(sampleShift+1))&1);
			if(ix<4*samplesPerTrans)
				System.out.println("LeaderByteA: "+ix+": "+((ix>>sampleShift+1)&1));
		}

		for(int ix=(toneLen/4);ix<(toneLen/4)+2*samplesPerTrans;ix++) {
			GenToneBit(tone,ix,((ix>>sampleShift)&1));
			System.out.println("LeaderByte: "+ix+": "+(((ix>>sampleShift)&1)));
		}
		
		int toneLevel=0;
		int dataByte=0x2d;	// msb first.
		int pos=(toneLen/4)+2*samplesPerTrans;
		for(int bit=0;bit<8;bit++) {
			if( ((dataByte>>(7-bit))&1)==0) {
				pos=GenToneBitMsg(tone,pos,toneLevel);
			}
			pos=GenToneBitMsg(tone,pos,toneLevel);
			toneLevel=1-toneLevel;
		}
		System.out.println("<LeaderByte");
		GenTone(tone);
	}

	/*
	(:) ctape ( amp val -- amp' )
		begin
		  #lit gSysVars_swUartState ic@
		8 < until
		dup #lit gSysVars_swUartCh ic! ( src amp [src])
		dup 1 >> audCount swap audCount neg + 2dup xor 0<	( src amp pCount ~phase)
		dup #litc kMicOutputPhase and
		#litc kMicOutputBuffLoad or #litc 0x15 #lit gSysVars_swUartState >port> drop
		0= 2* 1+ * +	( src amp+pCount*[[phase*2]+1] )
	;

	(:) >tape ( src frames --)
		0 swap 0 do		( src amp)
			0	( src amp crc)
			64 0 do
				>r
				over i + ic@ dup >r ctape
				r> r> crc
			loop
			>r r 255 and ctape r> 8 >> ctape
			0 ctape 0 ctape ( force lead)
		loop
	;
	*/

	public void DebugLog(int b) {
		if(iDebugLog!=null) {
			try {
				iDebugLog.write(b);
			} catch (Exception e) {
			  e.printStackTrace();
			}
		}
	}
	
	public void DebugLog(String s) {
		if(iDebugLog!=null) {
			try {
				iDebugLog.write(s);
			} catch (Exception e) {
			  e.printStackTrace();
			}
        }
	}
	
	int gSamplePhase=0;
	char[] gTransitions={ '_', '=', '*', '#' };
	
	public void DebugLogTrans(int aBit) {
		aBit=gSamplePhase*2+((aBit==0)?0:1);
		DebugLog(gTransitions[aBit]);
	}
	
	public int genAudioBits(byte[] data, int samplePos, byte bits, int bitCount) {
		int sampleBit=0;
		while(--bitCount>=0) {
			sampleBit=7-(samplePos&7);
			if((bits&0x80)==0) {
				data[samplePos>>3]=(byte)((data[samplePos>>3]&~(1<<sampleBit)) |
									(gSamplePhase<<(sampleBit)));
				DebugLogTrans(data[samplePos>>3]&(1<<sampleBit));				
				samplePos++;
			}
			sampleBit=7-(samplePos&7);
			data[samplePos>>3]=(byte)((data[samplePos>>3]&~(1<<sampleBit)) |
								(gSamplePhase<<(sampleBit)));
			DebugLogTrans(data[samplePos>>3]&(1<<sampleBit));				
			samplePos++;
			bits<<=1;
			gSamplePhase=1-gSamplePhase;
		}
		return samplePos;
	}
	
	/**
	 * 0x73 = 01 11 00 11.
	 * 0+1+0+1 - (1+1+0+1) = 2-3 = -1.
	 * 0x51 + 0x5 = 0x56 => 2+ 010101
	 * 00 11 10 01 = 0x39.
	 * 0x11+1 = 0x12 => 2+0 = 2.
	 * 3-2 = 1.
	 **/
	public int audCount(int aByte) {
		aByte=aByte&0x55;				// 0b0d0f0h
		aByte=(aByte+(aByte>>4))&15;				// 0000[f+b][d+h], 00 01 or 10.
		aByte=((aByte&3)+(aByte>>2))&7;		// 0000[f+b][d+h] + 000b0d[f+b] = 0b0d[f+b][d+h+f+b]
		DebugLog(":"+aByte+":");
		return aByte;
	}
	
	public int genAudioByte(byte[] data, int samplePos, byte aByte) {
		// need to generate the polarity bit, either 2x1 or 1x0 (to invert).
		// add all the odd bits and subtract all the even bits.
		int amp=audCount(aByte>>1)-audCount(aByte);
		if((amp^gSampleBias)<0) {
			samplePos=genAudioBits(data,samplePos,(byte)0xc0,2); // 2x '1' bits.
			gSampleBias+=amp;
		}
		else {
			samplePos=genAudioBits(data,samplePos,(byte)0x00,1); // 1x '0' bit.
			gSampleBias-=amp+((gSamplePhase!=0)?1:-1);
		}
		samplePos=genAudioBits(data,samplePos,aByte,8); // Send remaining bits
		return samplePos;
	}

	public int genCrc(int crc,int aByte) {
	   crc  = (crc >> 8) | (crc << 8)&0xffff;
	   crc ^= aByte;
	   crc ^= (crc & 0xff) >> 4;
	   crc ^= crc << 12;
	   crc ^= (crc & 0xff) << 5;
	   return crc&0xffff;
	}

	public final static int kPacketBits=66*18+50;
	public int genPacket(byte[] packet, byte[] data, int samplePos) {
		int bytePos;
		int crc=0xffff;
		DebugLog("Lead: ");				
		for(int leadBytes=0;leadBytes<6;leadBytes++) {
				samplePos=genAudioBits(data,samplePos,(byte)0,8);
				if(iDebugLog!=null) {
					//DebugLog((gSamplePhase==0)?"__##__##__##__## ":"##__##__##__##__ ");
					if((leadBytes&3)==3)
						DebugLog("\r\t");
				}
		}	// ends on high.
		// start pulse is two marker bits.
		samplePos=genAudioBits(data,samplePos,(byte)0xc0,2);	// top 2 bits always and they're ones.
		DebugLog("\rData["+samplePos+"]:["+packet[0]+","+gSampleBias+"]");
		gSampleBias=audCount(packet[0]>>1)-audCount(packet[0]);
		samplePos=genAudioBits(data,samplePos,packet[0],8);	// gen 8 bits of first sample.
		crc=genCrc(crc,packet[0]&255);
		for(bytePos=1;bytePos<64;bytePos++) {
			byte aByte=packet[bytePos];
			DebugLog("["+aByte+","+gSampleBias+"]");
			samplePos=genAudioByte(data,samplePos,aByte);
			if(iDebugLog!=null) {
				if((bytePos&3)==3)
					DebugLog("\r\t");
			}
			crc=genCrc(crc,aByte&255);
		}
		DebugLog(" Crc:"+crc+":");
		samplePos=genAudioByte(data,samplePos,(byte)(crc&255));	// finally send the crc lo
		samplePos=genAudioByte(data,samplePos,(byte)(crc>>8));	// and the crc hi.
		return samplePos;
	}

	public final static int kBinFilePreamble=1;
	public final static int kBinFileStateHeader=2;
	public final static int kBinFileStateData=3;
	public final static int kBinFilePostamble=4;
	public final static int kBinFileStateDone=-1;
	int gBinFileState=0,gSampleBias=0;
	byte[] gPacket=null;
	byte[] data;
	int kLeaderLength=22048; // 11024; // just under 2s worth.
	
	// binFileState fills data and returns the number of bytes to play.
	public int binFileAmble(int samplePos, int leaderLength) {
		int ix;
		DebugLog("\rGen Amble: ");				
		for(ix=0;ix<leaderLength/8;ix++) {
			//data[ix]=(byte)((gSamplePhase==0)?0x33:0xc0);	// Leader pattern.
			samplePos=genAudioBits(data,samplePos,(byte)0,8);
			if(iDebugLog!=null) {
				//DebugLog((gSamplePhase==0)?"__##__##":"##__##__" );
				if((ix&3)==3)
					DebugLog("\r\t");			
			}
		} // ends on a high.
		//samplePos+=leaderLength;
		gBinFileState=kBinFileStateHeader;
		return samplePos;
	}

	final static byte[] gCliHeaderName={ 'c', 'l', 'i', 0 };
	
	public int binFileCliHeader(int samplePos, int targetLoc, int dataLen) throws IOException {
		// begins with a 1.
		int ix;
		DebugLog("\rGen Cli Header: ");				
		gPacket[0]=TapePlayer.kTapeRam;
		gPacket[1]=(byte)((dataLen/64)&255);	// low byte of length.
		gPacket[2]=(byte)(dataLen/8192);	// hi byte of length.
		gPacket[3]=(byte)(targetLoc&255);
		gPacket[4]=(byte)(targetLoc/256);
		for(ix=0;ix<gCliHeaderName.length;ix++)
			gPacket[ix+5]=gCliHeaderName[ix];
		gPacket[gCliHeaderName.length+5]=0;	// terminate with 0.
		gBinFileState=kBinFileStateData;
		samplePos=genPacket(gPacket,data,samplePos);
		return samplePos;
	}
	
	public int binFileHeader(String audioName,int samplePos, int fileType, int targetLoc, int packets) throws IOException {
		// begins with a 1.
		int ix;
		DebugLog("\rGen Header: ");				
		gPacket[0]=(byte)fileType;
		gPacket[1]=(byte)(packets&255);	// low byte of length.
		gPacket[2]=(byte)(packets/256);	// hi byte of length.
		gPacket[3]=(byte)(targetLoc&255);
		gPacket[4]=(byte)(targetLoc/256);
		byte[] fName=audioName.getBytes("UTF-8");
		for(ix=0;ix<fName.length;ix++)
			gPacket[ix+5]=fName[ix];
		gPacket[fName.length+5]=0;	// terminate with 0.
		gBinFileState=kBinFileStateData;
		samplePos=genPacket(gPacket,data,samplePos);
		return samplePos;
	}

	public int binFileHeader(File audioFile,int samplePos, int fileType, int targetLoc, int packets) throws IOException {
		// begins with a 1.
		return binFileHeader(audioFile.getName(),samplePos, fileType, targetLoc, packets);
	}


	int SetWord(byte[] packet, int offset, int value, boolean bigEndian) {
		if(bigEndian) {
			packet[offset]=(byte)(value>>8);
			packet[offset+1]=(byte)(value&255);
		}
		else {
			packet[offset]=(byte)(value&255);
			packet[offset+1]=(byte)(value>>8);
		}
		return offset+2;
	}

	int SetString(byte[] packet, int offset, String str) throws IOException {
		byte[] strBytes=str.getBytes("UTF-8");
		for(int ix=0;ix<strBytes.length;ix++) {
			packet[offset++]=strBytes[ix];
		}
		packet[offset++]=(byte)0; // terminate the string.
		return offset;
	}

	final static int kCliStartAddr=0x8018;
	int[] cRamLoaderUserVars = {
/**
		&LastLink,	// a pointer to latest. Initially it contains LastLink.
		1,	// no warning.
		0xffff,	// no marker.
		0xffff,	// top of 32Kb ram.
		0,	// no claimed blk.
		0,	// no claimed blks.
		0,	// no block number.
		0,	// no fp parsing info.
		0x8080,	// initial value for here.
		0,	// state =0
		10, // base = decimal
		0, // hld=0.
**/
		0x8020,	// tib now starts here.
		0, 0, 0	// unused.
	};

	public int genPackets(byte[] sourcePacket, byte[] data, int samplePos) {
		int dstPos=0,pos=0;
		while(pos<sourcePacket.length) {
			if(dstPos>=gPacket.length) {
				samplePos=genPacket(gPacket,data,samplePos);
				dstPos=0;
			}
			gPacket[dstPos++]=sourcePacket[pos++];
		}
		while(dstPos<gPacket.length)
			gPacket[dstPos++]=(byte)0;	// fill rest with 0s.
		return genPacket(gPacket,data,samplePos);
	}

	final static int kLoaderPackets=4; // two headers+128b for the basic program.
	final static int kLoaderPayloadSize=128;

	public int binFileRamLoader(String payload,int samplePos) throws IOException {
		byte[] loaderBlock=new byte[kLoaderPayloadSize];
		int samples=256,ix,pos=0;
		for(ix=0;ix<cRamLoaderUserVars.length;ix++) {
			pos=SetWord(loaderBlock, pos, cRamLoaderUserVars[ix], true);
		}
		// this loads in the next program then sets tib to point to the load addr.
		pos=SetString(loaderBlock,pos,payload);
		DebugLog("\rGen Packet: ");
		samplePos=genPackets(loaderBlock,data,samplePos); // rest are just copies, dummy data.
		return samplePos;
	}

	public int binFileData(InputStream audioStream , int samplePos, boolean isText) throws IOException {
		int samples=256,ix;
		int bytesRead=audioStream.read(gPacket);	// read up to 64b
		if(bytesRead<gPacket.length) {	// we finish if we've read all the data.
			gBinFileState=kBinFileStateDone;
			if(isText) {
				if(bytesRead<0)
					bytesRead=0;
				gPacket[bytesRead++]=(byte)0;	// terminate and inc bytes read.	
			}	
		}
		if(bytesRead>0) {	// only generate a new packet if we've read >1 byte one way or another.
			DebugLog("\rGen Packet: ");
			samplePos=genPacket(gPacket,data,samplePos);
		}
		return samplePos;
	}

	public int packets(int byteCount) {
		return byteCount/kAudioFrameSize;
	}

	public int diskBlocks(int byteCount) {
		return byteCount/kDiskBlkSize;
	}

	public int diskPages(int byteCount) {
		return byteCount/kDiskPgSize;
	}

	public void BinGen(String pwd, String fName) { // eventually this will generate a program to load to flash.
		gBinFileState=kBinFilePreamble;
		File audioFile = new java.io.File(pwd,fName);
		int samplePos=0;
		boolean isText=fName.endsWith(".fth") || fName.endsWith(".txt");
		gSamplePhase=0;
		gPacket=new byte[64];
		try {
			int effectiveLength=(int)audioFile.length()+(isText? 1:-5);
			data=new byte[ ((effectiveLength+127)/64)*kPacketBits +kLeaderLength/2+1];
			InputStream audioStream = new FileInputStream(audioFile);
			int startAddr=kCliStartAddr;
			int fileType=TapePlayer.kTapeRam;
			if(isText==false) {	// get the type and start from the first 5 bytes.
				byte[] info=new byte[5];
				audioStream.read(info);
				fileType=info[0];
				startAddr=getWord(info,3);
				System.out.println(" Bin File: Type="+fileType+" start="+startAddr);
			}
			samplePos=binFileAmble(samplePos,kLeaderLength);
			samplePos=binFileHeader(audioFile,samplePos,fileType,startAddr,packets(effectiveLength));
			do {
				samplePos=binFileData(audioStream,samplePos,isText);
			}while(gBinFileState!=kBinFileStateDone);
			samplePos=binFileAmble(samplePos,kLeaderLength/4);
			System.out.println("Done Bin, len="+data.length);
			for(int ix=0;ix<data.length;ix++) {
				System.out.print(""+(Integer.toHexString(data[ix]&0xff))+", ");
				if((ix&15)==15)
					System.out.println("");
			}
			System.out.println("};");
			toneFormat= new AudioFormat(44100, 16, 2, true, false);
			tapePlayer=new TapePlayer(toneFormat,data,samplePos,sampleShift);
			audioStream.close();
        } catch (Exception ex) {
			System.out.println("Exception: "+ex);
        	ex.printStackTrace();
        }
	}
	
	public void TwoStageRamLoader(String pwd, String fName, int kFType, int loadAddr, String cli) {
		gBinFileState=kBinFilePreamble;
		File audioFile = new java.io.File(pwd,fName);
		int samplePos=0;
		boolean isText=fName.endsWith(".fth") || fName.endsWith(".txt");
		gSamplePhase=0;
		gPacket=new byte[64];
		try {
			int effectiveLength=((int)audioFile.length()+(isText? 1:0)+63)&~63;
			data=new byte[ (effectiveLength/64+kLoaderPackets)*kPacketBits +kLeaderLength*3/4+1];
			InputStream audioStream = new FileInputStream(audioFile);

			samplePos=binFileAmble(samplePos,kLeaderLength);
			// first part of a two-stage loader loads into RAM from kCliStartAddr.
			samplePos=binFileHeader(audioFile,samplePos,TapePlayer.kTapeRam,kCliStartAddr,packets(kLoaderPayloadSize));
			samplePos=binFileRamLoader(cli,samplePos);

			samplePos=binFileAmble(samplePos,kLeaderLength/2);
			samplePos=binFileHeader(audioFile,samplePos,kFType,loadAddr,packets(effectiveLength));
			do {
				samplePos=binFileData(audioStream,samplePos,isText);
			}while(gBinFileState!=kBinFileStateDone);
			samplePos=binFileAmble(samplePos,kLeaderLength/4);
			System.out.println("Done Bin, len="+data.length);
			for(int ix=0;ix<data.length;ix++) {
				System.out.print(""+(Integer.toHexString(data[ix]&0xff))+", ");
				if((ix&15)==15)
					System.out.println("");
			}
			System.out.println("};");
			toneFormat= new AudioFormat(44100, 16, 2, true, false);
			tapePlayer=new TapePlayer(toneFormat,data,samplePos,sampleShift);
			audioStream.close();
        } catch (Exception ex) {
			System.out.println("Exception: "+ex);
        	ex.printStackTrace();
        }
	}
	
	public void RunBinGen(String pwd, String fName) {
		File audioFile = new java.io.File(pwd,fName);
		int samplePos=0;
		boolean isText=fName.endsWith(".fth") || fName.endsWith(".txt");
		gSamplePhase=0;
		gPacket=new byte[64];
		try {
			int effectiveLength=((int)audioFile.length()+(isText? 1:0)+63)&~63;
			int loadAddr=0;
			TwoStageRamLoader(pwd, fName, TapePlayer.kTapeRam, loadAddr, " 19 kern 7 + ic@ ear top @ "+effectiveLength+" - tib !");
        } catch (Exception ex) {
			System.out.println("Exception: "+ex);
        	ex.printStackTrace();
        }
	}

	public void doCli() {
		System.out.println("cmdCli!");
		gBinFileState=kBinFilePreamble;
		int samplePos=0;
		boolean isText=true;
		gSamplePhase=0;
		gPacket=new byte[64];
		gCliText=cliArea.getText();
		try {
			int effectiveLength=gCliText.length();
			data=new byte[ ((effectiveLength+63)/64+kLoaderPackets)*kPacketBits +kLeaderLength/2+1];

			samplePos=binFileAmble(samplePos,kLeaderLength);
			samplePos=binFileCliHeader(samplePos,kCliStartAddr,kLoaderPayloadSize);
			samplePos=binFileRamLoader(gCliText,samplePos);

			samplePos=binFileAmble(samplePos,kLeaderLength/2);
			System.out.println("Done Cli, len="+data.length);
			for(int ix=0;ix<data.length;ix++) {
				System.out.print(""+(Integer.toHexString(data[ix]&0xff))+", ");
				if((ix&15)==15)
					System.out.println("");
			}
			System.out.println("};");
			toneFormat= new AudioFormat(44100, 16, 2, true, false);
			tapePlayer=new TapePlayer(toneFormat,data,samplePos,sampleShift);
        } catch (Exception ex) {
			System.out.println("Exception: "+ex);
        	ex.printStackTrace();
        }
	}

	/**
	 * These routines handle conversion from a bit-based format to text.
	 **/
	public final static int kCaptureLead=0;
	public final static int kCaptureLeadMark=1;
	public final static int kCaptureMark=2;
	public final static int kCaptureDataM=3;
	public final static int kCaptureData0=4;
	public final static int kCaptureData1=5;
	public final static int kCaptureData2=6;
	public final static int kCaptureData3=7;
	public final static int kCaptureData4=8;
	public final static int kCaptureData5=9;
	public final static int kCaptureData6=10;
	public final static int kCaptureData7=11;
	public final static int kCaptureSkip=12;
	
	public final static int kAudioFrameSize=64;
	public final static int kDiskPgSize=256;
	public final static int kDiskBlkSize=512;
	
	public int gCaptureState=kCaptureLead;
	public int gCaptureData=0;

	public int decodeTapeBit(byte[] srcBits, int bitPos, byte[] dst, int head, int tail) {
		int bit=(srcBits[bitPos>>3]>>(7-(bitPos&7)))&1;
		switch(gCaptureState) {
		case kCaptureLead:
			if(gCaptureData>=16) {
				if(bit==1)
					gCaptureState=kCaptureDataM;	// we need another 1 bit to get out of the lead.
			}
			else {
				if(bit==1)
					gCaptureData=0;
				else
					gCaptureData++;
			}
			break;
		case kCaptureSkip:
			break;
		case kCaptureMark:	// 0 => data, 1=>Mark.
			gCaptureState=kCaptureData0-bit; // So that picking up a '0'=> Data0 state, picking up a '1'=>DataM.
			break;
		case kCaptureData7: // we've had 8 bits.
			gCaptureData=((gCaptureData<<1)|bit)&0xff;
			if(head<dst.length) {
				dst[head++]=(byte)gCaptureData;
				System.out.print(" "+(gCaptureData&0xff));
				if(gCaptureData>=' ' && gCaptureData<=127) {
					System.out.print("("+(char)gCaptureData+")");
				}
			}
			else {
				head++;
				System.out.print(":"+(gCaptureData&0xff));
			}
			if((head&15)==0)
				System.out.println("");
			gCaptureData=0;
			gCaptureState=kCaptureMark;
			if(head==tail+kAudioFrameSize+2) {
				gCaptureState=kCaptureLead;
				head-=2; // reset the head to just before the crc.
			}
			break;
		default:
			gCaptureData=(gCaptureData<<1)|bit;	// include the next bit.
			gCaptureState++;	// next state.
			break;
		}
		return head;
	}
	
	/**
	 * In the Java decoding, we can also do scatter loading, but not yet.
	 * at the moment we can only report a crc error.
	 **/

	public void LogBlock(String msg, byte[] data) {
		DebugLog("\n"+msg+"{");
		int frame=0;
		for(int ix=0;ix<data.length;ix++) {
			if((ix&63)==0) {
				DebugLog("\nFrame["+frame+"]\t");
				frame++;
			}
			else if((ix&15)==0) {
				DebugLog("\n\t\t");
			}
			DebugLog(""+(Integer.toHexString(data[ix]&0xff))+", ");
		}
		DebugLog("};");
	}

	boolean gCaptureMatch=true;
	int gCalcCrc=0,gAudioCrc=0;
	public int decodeTapeFrame(byte[] dst, int head, int tail) {
		int ix,audioCrc,calcCrc;
		if(gCaptureState==kCaptureLead && head-tail==kAudioFrameSize) {
			gCaptureMatch=true;
			audioCrc=(dst[head]&0xff)+((dst[head+1]&0xff)<<8);
			calcCrc=0xffff;
			do {
				calcCrc=genCrc(calcCrc,dst[tail]&0xff);
			}while(++tail<head);
			if(calcCrc!=audioCrc)
				gCaptureMatch=false;
			gCalcCrc=calcCrc;
			gAudioCrc=audioCrc;
		}
		return tail;
	}
	
	public int getWord(byte[] src,int offset) {
		return (src[offset]&0xff)+((src[offset+1]&0xff)<<8);
	}

	String getString(byte[] src, int offset, int maxLen) {
		int len=0;
		String res=null;
		while(len<maxLen && src[offset+len]!=0)
			len++;
		try {
			res=new String(src,offset,len,"UTF-8");
		}
		catch(Exception ex) {
			System.out.println("Exception: "+ex);
		}
		return res;
	}

	public int tapeHeaderType=0;
	public int tapeHeaderLength=0;
	public int tapeHeaderStart=0;
	public String tapeHeaderName="";
	
	public boolean decodeTapeHeader(byte[] dst,boolean match) {
		if(match) {
			tapeHeaderType=dst[0]&0xff;
			tapeHeaderLength=getWord(dst,1);
			tapeHeaderStart=getWord(dst,3);
			tapeHeaderName=getString(dst,5,63-5);
		}
		return match;
	}
	
	@SuppressWarnings("unchecked")
	public LinkedList decodeTape(byte[] srcBits) {
		LinkedList list=new LinkedList();
		byte[] dst=new byte[kAudioFrameSize+2]; // space for a header. srcBits.length];
		byte[] badPacket=new byte[(srcBits.length+(kAudioFrameSize*8)-1)/(kAudioFrameSize*8)]; // all 0s?
		badPacket[0]=(byte)0;
		int bitPos=0,head=0,tail=0,packet=0,newTail=0;
		boolean expectingHeader=true,RLoadingError=false;
		gCaptureState=kCaptureLead;
		gCaptureMatch=true;
		do {
			head=decodeTapeBit(srcBits,bitPos,dst,head,tail);
			newTail=decodeTapeFrame(dst,head,tail);
			if(newTail!=tail) {	// new packet!
				if(gCalcCrc==gAudioCrc)
					System.out.print("New Packet:"+(newTail/kAudioFrameSize));
				else {
					System.out.print("New (Bad) Packet:"+(newTail/kAudioFrameSize)+
								" Read "+gAudioCrc+" Calcd"+gCalcCrc);
					badPacket[0]++; // increase bad packets.
				}
				if(expectingHeader) {	// header?
					expectingHeader=!decodeTapeHeader(dst,gCaptureMatch);
					if(expectingHeader) {
						LogBlock("Header Error"+gAudioCrc+" "+gCalcCrc,dst);
						System.out.println("Header Error"+gAudioCrc+" "+gCalcCrc);
					}
					else {	// good header, add to list and create array for body.
						LogBlock("Header["+tapeHeaderType+"]:"+tapeHeaderName+" Len:"+tapeHeaderLength+
								" Start:"+tapeHeaderStart,dst);
						System.out.println("Header["+tapeHeaderType+"]:"+tapeHeaderName+" Len:"+tapeHeaderLength+
								" Start:"+tapeHeaderStart);
						list.add(dst);
						if(tapeHeaderType==TapePlayer.kExtFlash)
							tapeHeaderLength <<=3;	// 8 packets per block.
						if(tapeHeaderLength>0) {
							dst=new byte[tapeHeaderLength*kAudioFrameSize+2];
						}
						else {
							dst=new byte[kAudioFrameSize+2];
							expectingHeader=true;
						}
					}
					head=tail=0;	// reset head and tail if there was a glitch.
				}
				else {	// expecting body.
					System.out.println("(Body)");
					tail=newTail;
					if(tail/kAudioFrameSize>=tapeHeaderLength) {	// we have the entire body.
						LogBlock("Body",dst);
						list.add(dst);	// add the new block to the dst.
						dst=new byte[kAudioFrameSize+2];	// get ready for a new header.
						head=tail=0;	// and reset head/tail.
						expectingHeader=true;
					}
				}
			}
		}while(++bitPos<(srcBits.length<<3));
		// At the end we add badPacket array.
		list.addFirst(badPacket);
		return list;
	}
	
	/**
	 * Tapes consist of a list of byte arrays containing either headers or
	 * bodies. Headers that have a name which ends in .fth are text files and
	 * the last section with that name is the correct one of that kind.
	 * Headers that have the name 'cli' are command lines, they replace the current
	 * command line text.
	 * All other headers are ffb files (FIGnition Forth Binary) files and are saved
	 * as-is.
	 * We do a save-per file.
	 **/
	public void fileSave(String fName, int start, int len, int fType, byte[] body) {
		FileDialog fd=new FileDialog(root,"Open",FileDialog.SAVE);
		fd.setDirectory(pwd);
		fd.setFile(fName);
		fd.setVisible(true);
		fName=fd.getFile();
		if(fName!=null) {
			pwd=fd.getDirectory();	// remember it for next time.
			if(fType==TapePlayer.kTapeRam && !fName.endsWith(".fth")) {
				// if ram file and doesn't end in .Fth then we treat as image, adding
				// type, length and start to the image.
				System.out.println("Binary file "+fName);
				byte[] newBody= new byte[body.length+5];
				newBody[0]=(byte)fType;
				SetWord(newBody,1,len,false);
				SetWord(newBody,3,start,false);
				for(int ix=0;ix<body.length;ix++) {
					newBody[ix+5]=body[ix];
				}
				body=newBody;	// copied image back to body.
				len=newBody.length;
			}
			else if(fName.endsWith(".fth") || fName.endsWith(".txt")) {
				// it's a text file, find the first 0 in the last block.
				boolean searching=true;
				for(int ix=0;ix<body.length && searching ;ix++) {
					if(body[ix]==0) {
						searching=false;
						len=ix;	// terminate the length here.
					}
				}
			}
			else if(fType==TapePlayer.kExtFlash)
				len*=512;	// length is really the number of blocks.
			try {
				File fRef=new File(pwd,fName);
				FileOutputStream fStream=new FileOutputStream(fRef);
				fStream.write(body,0,len);
				fStream.close();	// done!
				System.out.println("Saved "+pwd+"/"+fName+", "+len+" bytes.");
			}
			catch(Exception ex) {
				System.out.println("Exception: "+ex);
			}
		}
		else
			System.out.println("Save Cancelled");
	}
	
	public void saveTape(LinkedList tape) {
		boolean expectsHeader=true;
		String lastFileName="";
		int lastStart=0,lastLen=0,lastType=0;
		boolean nameChanged=false;
		byte[] lastBody=null;
		byte[] loadingErrors=(byte[])tape.removeFirst();

		if(loadingErrors.length>0 && loadingErrors[0]!=0) {	// it didn't load OK, need alert.
			//JOptionPane dialog=new JOptionPane((Object)("R:Tape Loading Errors"+loadingErrors[0]),
			//					JOptionPane.ERROR_MESSAGE);
			//dialog.setVisible(true);
			//tape=null;
			//return;
			System.out.println("R: Tape Loading Errors.");
		}

		for(int ix=0;ix<tape.size();ix++) {
			byte[] packets=(byte[])tape.get(ix);
			if(expectsHeader) {	// process a header.
				decodeTapeHeader(packets,true);	// get the header info.
				if(tapeHeaderLength>0) {	// a body follows.
					expectsHeader=false;
					if(lastFileName.equals(tapeHeaderName)==false && lastLen>0) {	// we need to save previous.
						fileSave(lastFileName,lastStart,lastLen,lastType,lastBody);
					}
					lastFileName=tapeHeaderName;
					lastStart=tapeHeaderStart;
					lastLen=tapeHeaderLength;
					lastType=tapeHeaderType;
				}
				else {
					expectsHeader=true;	// if there's no body, then another header follows.
				}
			}
			else {
				lastBody=packets;
			}
		}
		if(lastLen>0)
			fileSave(lastFileName,lastStart,lastLen,lastType,lastBody);
	}

	/**
	 * Convert input stream in 
	 * We ignore chr(13), chr(10).
	 * Else we convert chr(x), chr(10) to chr(13).
	 * Else we ignore chr(10), chr(13)
	 **/
	public int gFilterCrLen=0;
	public byte[] gCrcFixed=null;
	public ByteArrayInputStream filterCr(InputStream in,long len) throws IOException {
		gFilterCrLen=0;
		gCrcFixed=new byte[(int)len];
		int b=0,ob=0;
		do {
			ob=b;
			b=in.read();	// get a byte.
			System.out.print(""+(char)b);
			if(b==10) {	// it's lf, change to cr?
				if(ob!=13)	// cr,lf pattern ignores the lf.
					gCrcFixed[gFilterCrLen++]=13;
			}
			else if(b==13) {	// it's cr.
				if(ob!=10)	// not lf,cr pattern, the previous char
							// wasn't an lf converted to a cr, so we can do that now.
					gCrcFixed[gFilterCrLen++]=13;
				else {	// lf,cr pattern, we converted the previous lf to a cr
						// don't want to confuse next lf with cr,lf.
					b=0;	// so lf,cr => gen<cr>, 0. 
					System.out.println("b=0");
				}
			}
			else if(b!=-1) {
				if(gFilterCrLen<gCrcFixed.length)
					gCrcFixed[gFilterCrLen++]=(byte)b;
				else
					System.out.println(" Ooops too long! ");
			}
		}while(b!=-1);
		return new ByteArrayInputStream(gCrcFixed,0,gFilterCrLen);
	}

	/**
	 * Loading and saving to external Flash
	 **/			
	// a 3 stage loader.
	public void loadExtFlash(String pwd, String fName) {
		File targetFile = new java.io.File(pwd,fName);
		//File flashLoaderFile = new File(FIGgyTapeFrame.class.getProtectionDomain().
		//							getCodeSource().getLocation().getPath(),"start/ExtFlashLoader.fth");
		Object[] flashLoaderObj = getRelativeFile("fth/","ExtFlashLoader.fth");

		int samplePos=0;
		boolean isText=fName.endsWith(".fth") || fName.endsWith(".txt");
		gSamplePhase=0;
		gPacket=new byte[64];
		try {
			int flashLoaderLen=(((Integer)flashLoaderObj[relFileLen]).intValue()&~63)+64;
			int targetFileLength=((int)targetFile.length()+(isText? 1:0)+511)&~511;
			InputStream flashLoaderStream = ((InputStream)flashLoaderObj[relFileStream]);
			InputStream targetStream = new FileInputStream(targetFile);
			if(isText) {
				targetStream=filterCr(targetStream,targetFile.length());
				targetFileLength=((int)gFilterCrLen+(isText? 1:0)+511)&~511;
			}
			String cli="19 kern 7 + ic@ ear "+(targetFileLength>>9)+" top @ "+flashLoaderLen+" - tib ! ";
			data=new byte[ ((targetFileLength+flashLoaderLen)/64+kLoaderPackets*2+3)*kPacketBits +kLeaderLength+1];

			samplePos=binFileAmble(samplePos,kLeaderLength);
			// first part of a three-stage loader loads a command line into the TIB
			samplePos=binFileHeader(((String)flashLoaderObj[relFileName]),samplePos,TapePlayer.kTapeRam,
											kCliStartAddr,packets(kLoaderPayloadSize));
			samplePos=binFileRamLoader(cli,samplePos);
			
			// the cli now runs, loading the next section in (the ExtFlash loader)
			samplePos=binFileAmble(samplePos,kLeaderLength/2);
			samplePos=binFileHeader(((String)flashLoaderObj[relFileName]),samplePos,TapePlayer.kTapeRam,0,packets(flashLoaderLen));
			gBinFileState=kBinFilePreamble;
			do {
				samplePos=binFileData(flashLoaderStream,samplePos,true);
			}while(gBinFileState!=kBinFileStateDone);
			
			// the ExtFlash loader runs, loading in the actual Flash data.
			samplePos=binFileAmble(samplePos,kLeaderLength);
			samplePos=binFileHeader(targetFile,samplePos,TapePlayer.kExtFlash,0,diskBlocks(targetFileLength));
			gBinFileState=kBinFilePreamble;
			do {
				samplePos=binFileData(targetStream,samplePos,isText);
				targetFileLength-=kAudioFrameSize;
			}while(gBinFileState!=kBinFileStateDone);
			
			if(targetFileLength>0) {
				for(int ix=0;ix<gPacket.length;ix++)
					gPacket[ix]=(byte)0; // fill the packets with 0xff's.
				while(targetFileLength>0) {
					samplePos=genPacket(gPacket,data,samplePos);
					targetFileLength-=kAudioFrameSize;
				}
			}

			// Finally, a leader finishes the audio.
			samplePos=binFileAmble(samplePos,kLeaderLength/4);
			
			
			System.out.println("Done Bin, len="+data.length+" Samples="+samplePos+" cli="+cli);
			for(int ix=0;ix<data.length;ix++) {
				System.out.print(""+(Integer.toHexString(data[ix]&0xff))+", ");
				if((ix&15)==15)
					System.out.println("");
			}
			System.out.println("};");
			toneFormat= new AudioFormat(44100, 16, 2, true, false);
			tapePlayer=new TapePlayer(toneFormat,data,samplePos,sampleShift);
			flashLoaderStream.close();
			targetStream.close();
        } catch (Exception ex) {
			System.out.println("Exception: "+ex);
        	ex.printStackTrace();
        }
	}

	public ByteArrayInputStream binFileBytes(File binFile) throws IOException {
		gCrcFixed=new byte[((int)binFile.length()+255)&~255];	//
		FileInputStream binStream=new FileInputStream(binFile);
		binStream.read(gCrcFixed);	// read all the bytes in in one go.
		for(int ix=(int)binFile.length();ix<gCrcFixed.length;ix++)
			gCrcFixed[ix]=(byte)-1;	// pad out with -1.
		return new ByteArrayInputStream(gCrcFixed);
	}
	
	public int genCrcPacket(byte[] gPacket, byte[] data,int samplePos,byte[] firmware,int page) {
		DebugLog("\n Crcs:");
		for(int pktCrcs=0;pktCrcs<32;pktCrcs++) {
			int crc=0xffff;
				for(int ix=page*256;ix<page*256+256;ix++) {
					if(ix<firmware.length)
						crc=genCrc(crc,firmware[ix]&0xff);
					else
						crc=genCrc(crc,-1);	// pretend data is -1 - is that correct?
			}
			if((pktCrcs&7)==7)
				DebugLog(" Pg["+page+"] = "+crc);
			else
				DebugLog(" Pg["+page+"] = "+crc+"\n");
			System.out.print(" Crc for page "+page+" = "+crc);
			page++;
			SetWord(gPacket,pktCrcs*2, crc, true);
		}
		return genPacket(gPacket,data,samplePos);	// finally generate tones.
	}
	
	public void StopPlayRec() {
		if(tapePlayer!=null) {
			tapePlayer.tapeStop();
			tapePlayer=null;
		}
		if(tapeRecorder!=null) {
			tapeRecorder.tapeStop();
		}
	}
	
	// returns an object containing a stream, its name and its length or null
	public final static int relFileStream=0;
	public final static int relFileName=1;
	public final static int relFileLen=2;
	public Object[] getRelativeFile(String path, String name) {
	try {
		java.net.URL resourceURL=this.getClass().getResource(path+name);
		if (resourceURL != null) {
			Object[] objects=new Object[3];	// 3 items.
			objects[relFileStream]=resourceURL.openStream();	// ok that's the stream.
			objects[relFileName]=name;
			InputStream is=resourceURL.openStream();	// open another copy.
			byte[] dummyData=new byte[8192];	// maximum length for local files. 
			int len=is.read(dummyData);
			System.out.println("RelStream "+name+" len:"+len);
			is.close();
			objects[relFileLen]=new Integer(len);
			return objects;
		} else {
			System.err.println("Couldn't find file: " + path);
			return null;
		}
	}
	catch (Exception ex){
			System.out.println("Exception: "+ex);
        	ex.printStackTrace();
	}
	return null;
}

	
	public void loadUpgrade(String pwd, String fName,boolean migrate) {
		File targetFile = new java.io.File(pwd,fName);
		Object[] upgraderObj = getRelativeFile("fth/","Upgrader.fth");
		//File upgraderFile = new File("Upgrader.fth");
		int samplePos=0;
		gSamplePhase=0;
		gPacket=new byte[64];
		try {
			int upgraderLen=(((Integer)upgraderObj[relFileLen]).intValue()&~63)+64;
			int targetFileLength=((int)targetFile.length()+255)&~255;
			int crcPackets=(diskPages(targetFileLength)+31)/32;
			InputStream upgraderStream = ((InputStream)upgraderObj[relFileStream]);
			InputStream targetStream = binFileBytes(targetFile);
			String cli="19 kern 7 + ic@ ear "+diskPages(targetFileLength)+" top @ "+upgraderLen+" - tib ! ";
			data=new byte[ ((targetFileLength+upgraderLen)/64+kLoaderPackets*2+3)*kPacketBits +kLeaderLength+1];

			samplePos=binFileAmble(samplePos,kLeaderLength);
			// first part of a three-stage loader loads a command line into the TIB
			if(migrate==false) {
				DebugLog("Upgrader Cli\n");
				samplePos=binFileHeader(((String)upgraderObj[relFileName]),samplePos,TapePlayer.kTapeRam,
												kCliStartAddr,packets(kLoaderPayloadSize));
				samplePos=binFileRamLoader(cli,samplePos);
			
				// the cli now runs, loading the next section in (the upgrader program)
				samplePos=binFileAmble(samplePos,kLeaderLength/2);
				DebugLog("Upgrader Forth Program\n");
				samplePos=binFileHeader(((String)upgraderObj[relFileName]),samplePos,TapePlayer.kTapeRam,0,packets(upgraderLen));
				gBinFileState=kBinFilePreamble;
				do {
					samplePos=binFileData(upgraderStream,samplePos,true);
				}while(gBinFileState!=kBinFileStateDone);
			
				// the upgrader runs, loading in the actual Flash data.
				samplePos=binFileAmble(samplePos,kLeaderLength);
			}
			DebugLog("Upgrade Firmware\n");
			samplePos=binFileHeader(targetFile,samplePos,TapePlayer.kFigFirmware,0,diskPages(targetFileLength));
			gBinFileState=kBinFilePreamble;
			do {
				samplePos=binFileData(targetStream,samplePos,false);
				targetFileLength-=kAudioFrameSize;
			}while(gBinFileState!=kBinFileStateDone);
			
			DebugLog("Upgrade Firmware padding\n");
			if(targetFileLength>0) {	// pad out the file to the length of the code.
				for(int ix=0;ix<gPacket.length;ix++)
					gPacket[ix]=(byte)0; // fill the packets with 0xff's.
				while(targetFileLength>0) {
					samplePos=genPacket(gPacket,data,samplePos);
					targetFileLength-=kAudioFrameSize;
				}
			}

			for(int ix=0;ix<crcPackets;ix++) {
				samplePos=genCrcPacket(gPacket,data,samplePos,gCrcFixed,ix*32);
			}

			// A leader finishes the audio.
			samplePos=binFileAmble(samplePos,kLeaderLength/4);
			
			
			System.out.println("Done Bin, len="+data.length+" Samples="+samplePos+" cli="+cli);
			for(int ix=0;ix<data.length;ix++) {
				System.out.print(""+(Integer.toHexString(data[ix]&0xff))+", ");
				if((ix&15)==15)
					System.out.println("");
			}
			System.out.println("};");
			toneFormat= new AudioFormat(44100, 16, 2, true, false);
			tapePlayer=new TapePlayer(toneFormat,data,samplePos,sampleShift);
			upgraderStream.close();
			targetStream.close();
        } catch (Exception ex) {
			System.out.println("Exception: "+ex);
        	ex.printStackTrace();
        }
	}


	public void update(LineEvent le) {
		LineEvent.Type type = le.getType();
		if (type == LineEvent.Type.OPEN) {
			System.out.println("OPEN");
		} else if (type == LineEvent.Type.CLOSE) {
				System.out.println("CLOSE");
		} else if (type == LineEvent.Type.START) {
			System.out.println("START");
		} else if (type == LineEvent.Type.STOP) {
			System.out.println("STOP");
		}
	}


	 public void startLog(boolean state) {
	 	try {
			if(state && iDebugLog==null) {
				// setup iDebugLog
				iDebugLog=new FileWriter("DebugLog.txt",false);	// append.
			}
			else if(!state && iDebugLog!=null) {
				iDebugLog.close();	// close and flush.
				iDebugLog=null;
			}
		}catch( IOException e) {
          e.printStackTrace();
        }
	 }

	public void actionPerformed(ActionEvent e) {
		int cmd=kMaxCmds;
		String action=e.getActionCommand();
		System.out.println(action);
		for(int ix=0;ix<kMaxCmds;ix++) {
			if(cmdName[ix].equals(action))
				cmd=ix;
		}
		switch(cmd) {
		case kCmdTapeStart:
			statusLabel.setText("Start");
			fileNum=0;
			break;
		case kCmdTapeRew:
			if(fileNum>0)
				fileNum--;
			statusLabel.setText("File"+fileNum);
			break;
		case kCmdTapePlay:
			if(tapePlayer!=null) {
				if(butPlay.getText().equals("Play")) {
					statusLabel.setText("Playing");
					butPlay.setText("Pause");
					if(tapePlayer.pause(false)) {	// it wasn't paused before.
						tapePlayer.setAmp((double)vol.getValue()/100.0);
						//tapePlayer.iDebugLog=iDebugLog;
						tapePlayer.start();
					}
				}
				else {
					statusLabel.setText("Paused");
					butPlay.setText("Play");
					tapePlayer.pause(true);
				}
			}
			break;
		case kCmdTapeRec:
			statusLabel.setText("Rec");
			butPlay.setText("Play");
			if(GenRecorder(TapeRecorder.kRecordModeBin)!=null) {
				//tapeRecorder.setAmp((double)vol.getValue()/100.0); // master gain not supported.
				tapeRecorder.start();
			}
			break;
		case kCmdTapeStop:
			butPlay.setText("Play");
			statusLabel.setText("Stopped");
			StopPlayRec();
			break;
		case kCmdTapeFwd:
			if(fileNum<kLastFile)
				fileNum++;
			statusLabel.setText("File"+fileNum);
			break;
		case kCmdTapeEnd:
			fileNum=kLastFile;
			statusLabel.setText("End");
			break;
		case kCmdFileOpen:
			startLog(iDebugLogItem.getState());
			StopPlayRec();
			FileOpen();
			break;
		case kCmdFileRun:
			startLog(iDebugLogItem.getState());
			StopPlayRec();
			FileRun();
			break;
		case kCmdFileFlash:
			startLog(iDebugLogItem.getState());
			StopPlayRec();
			FileExtFlash();
			break;
		case kCmdFileUpgrade:
			startLog(iDebugLogItem.getState());
			StopPlayRec();
			FileUpgrade(false);
			break;
		case kCmdFileSave:
			if(tapeRecorder!=null) {
				startLog(iDebugLogItem.getState());
				LinkedList list=decodeTape(tapeRecorder.iSampleData);
				saveTape(list);
				tapeRecorder=null;
			}
			break;
		case kCmdSpeed44K:
		case kCmdSpeed22K:
		case kCmdSpeed11K:
			sampleShift=cmd-kCmdSpeed44K;
			sampleRate=(float)(44100.0/(float)(1<<sampleShift));
			break;
		case kCmdSpeed500:
			sampleShift=64;
			sampleRate=(float)(44100.0/(float)(sampleShift));
			break;
		case kCmdLeader:
			GenLeader();
			break;
		case kCmdLeaderStart:
			GenLeaderStart();
			break;
		case kCmdLeaderByte:
			GenLeaderByte();
			break;
		case kCmdSaw:
			GenSaw();
			break;
		case kCmdCli:
			startLog(iDebugLogItem.getState());
			doCli();
			break;
		case kCmdRecWav:
			statusLabel.setText("Rec (Wav)");
			startLog(iDebugLogItem.getState());
			if(GenRecorder(TapeRecorder.kRecordModeWav)!=null)
				tapeRecorder.start();
			doCli();
			break;
		case kCmdDebugLog:
			iDebugLogItem.setState(!iDebugLogItem.getState()); // invert it.
			break;
		case kCmdMigrate:
			startLog(iDebugLogItem.getState());
			StopPlayRec();
			FileUpgrade(true);
			break;
		default:
			System.out.println(" - Unimplemented");
			break;
		}
	} 

	public void stateChanged(ChangeEvent e) {
		JSlider slider = (JSlider)e.getSource();
        if (!slider.getValueIsAdjusting() && tapePlayer!=null) {
            tapePlayer.setAmp((double)slider.getValue()/100.0);
        }
    }

	public JButton makeButton(String name, String icon, int key, String cmd) {
		JButton button = new JButton(name, null);
		button.setMnemonic(key);
    	button.setActionCommand(cmd);
		button.addActionListener(this);
        transport.add(button);
        return button;
	}

	public MenuItem makeMenuItem(String name, int key, String cmd) {
		MenuItem item=new MenuItem(name);
		if(key!=0)
			item.setShortcut(new MenuShortcut(key));
		item.setActionCommand(cmd);
		return item;
	}

	public void init(JFrame frame) {
        //Create and set up the window.
        root=frame;
		setLayout(new BoxLayout(this,BoxLayout.PAGE_AXIS)); // whole stuff goes vertically in a box layout
		
		vol= new JSlider(JSlider.HORIZONTAL, 0, 100, 60);
		vol.setMajorTickSpacing(10);
		vol.setPaintTicks(true);
		vol.setPaintLabels(true);
		vol.addChangeListener(this);
		Dimension size=vol.getSize();
		vol.setSize(size.width,30);
		vol.setName("Vol");
		add(vol);

        statusLabel = new JLabel("Stopped");
        add(statusLabel);

		transport=new JPanel();
		transport.setLayout(new BoxLayout(transport,BoxLayout.LINE_AXIS));	// controls go across the transport.
		
		butTapeStart = makeButton("Start", null, KeyEvent.VK_OPEN_BRACKET, "cmdTapeStart");
		butRew = makeButton("Rew", null, KeyEvent.VK_LESS, "cmdRew");
		butPlay = makeButton("Play", null, KeyEvent.VK_SPACE,"cmdPlay");
		butRec = makeButton("Rec", null, KeyEvent.VK_R,"cmdRec");
		butStop = makeButton("Stop", null, KeyEvent.VK_PERIOD, "cmdStop");
		butFwd = makeButton("Fwd", null, KeyEvent.VK_GREATER, "cmdFwd");
		butTapeEnd = makeButton("End", null, KeyEvent.VK_CLOSE_BRACKET, "cmdTapeEnd");
		add(transport);
		
		cliArea= new JTextArea(gCliText,4,40);
        add(cliArea);

		menuBar=new MenuBar();
		menuFile=new Menu("File");
		menuFile.add(makeMenuItem("New",KeyEvent.VK_N,"cmdNew"));
		menuFile.add(makeMenuItem("Open..",KeyEvent.VK_O,"cmdOpen"));
		menuFile.add(makeMenuItem("Run..",KeyEvent.VK_R,"cmdRun"));
		menuFile.add(makeMenuItem("Flash..",KeyEvent.VK_F,"cmdFlash"));
		menuFile.add(makeMenuItem("Upgrade..",KeyEvent.VK_U,"cmdUpgrade"));
		menuFile.add(makeMenuItem("Close",KeyEvent.VK_W,"cmdClose"));
		menuFile.add(makeMenuItem("Save..",KeyEvent.VK_S,"cmdSave"));
		menuFile.addActionListener(this);
		menuBar.add(menuFile);

		menuSpeed=new Menu("Speed");
		menuSpeed.add(makeMenuItem("44K",KeyEvent.VK_4,"cmd44Kb"));
		menuSpeed.add(makeMenuItem("22K",KeyEvent.VK_2,"cmd22Kb"));
		menuSpeed.add(makeMenuItem("11K",KeyEvent.VK_1,"cmd11Kb"));
		menuSpeed.add(makeMenuItem("500",KeyEvent.VK_5,"cmd500b"));
		menuSpeed.addActionListener(this);
		menuBar.add(menuSpeed);

		menuTone=new Menu("Tone");
		menuTone.add(makeMenuItem("Leader",0,"cmdLeader"));
		menuTone.add(makeMenuItem("LeaderStart",0,"cmdLeaderStart"));
		menuTone.add(makeMenuItem("LeaderByte",0,"cmdLeaderByte"));
		menuTone.add(makeMenuItem("Saw",0,"cmdSaw"));
		menuTone.add(makeMenuItem("Cli",0,"cmdCli"));
		menuTone.add(makeMenuItem("Rec (pure Wav)",0,"cmdRecWav"));
		menuTone.addActionListener(this);
		menuBar.add(menuTone);

		menuDebug=new Menu("Debug");
		iDebugLogItem=new CheckboxMenuItem("Log");
		iDebugLogItem.setActionCommand("cmdDebugLog");
		menuDebug.add(iDebugLogItem);
		menuDebug.addActionListener(this);
		menuBar.add(menuDebug);

		menuSpecial=new Menu("Special");
		menuSpecial.add(makeMenuItem("Migrate..",0,"cmdMigrate"));
		menuSpecial.addActionListener(this);
		menuBar.add(menuSpecial);

		frame.setMenuBar(menuBar);
	}
	
}

