 const flPages
cls ." Pause tape. " cr
: inline 
  create -1 allot 
  dup 256 < if c, else , then 
  $80 latest lfa>ffa c! 
; immediate 
$B4 inline SerFlRd
$B5 inline SerFlWr
$C3 inline SerFlEr
$C4 inline SerFlId

11 kern inline VDskFind
12 kern inline crc
15 kern inline +tape>
16 kern inline -tape
17 kern inline tape>
1 const kFigFirmware
19 kern const packet
64 const packetLen
13 const .goodPackets
15 const .loadMap
4 const kPgFrames
vram 306 + const flBuff

flPages arr physBlks

: mapBit
  dup 3 >> packet + .loadMap + swap 7 and 1 swap <<
;

: mapClr
  mapBit neg 1- over ic@ and swap ic!
;

: chkMv ( src dst len -- f)
  >r 0 r 0 do ( sdf:l)
    >r over i + i@
    over i + i@
    over and - r> or
  2 +loop
  r> swap if
    2drop drop
  else
    cmove
  then
;

: fl 32 + flBuff ;

: tapeBlk> ( pg# --)
  dup fl SerFlRd
  kPgFrames 0 do ( pg# )
    0 tape> ( got packet, written into iRam; pg# buff|0 : gFrms)
    ?dup if
      flBuff i packetLen * + packetLen chkMv  ( merge frame to page.)
      0 packet .loadMap + ic! ( clrMap bit always)
    then
  loop
  fl SerFlWr ( pg# buf )
;

: chkPgs ( arr -- badPgs )
  flPages 31 + 5 >> 0 do
    0 tape>
    ?dup if
    	over i packetLen * + packetLen cmove ( cp packet to RAM )
    then
  loop
  flPages flPages 0 do ( af)
  	i fl SerFlRd
  	over @ -1 ( afcC)
  	flBuff dup 256 + swap do
  		i ic@ swap crc
  	loop
  	= + swap 2+ swap
  loop
  swap drop
;

: preErase
  cr
  ." Hit '!' to confirm, 'c'  to cancel."
  begin
    key dup emit
  dup asc ! = over asc c = or until
  asc ! - dup if
    cr ." Cancelled " ;s
  then
  128 32 do
    i SerFlEr
    SerFlId $2013 = if
      i
    else
      16
    then
  +loop
  cr ." Done. Hit key to upgrade."
  key drop
;

: upgradeEnd ( bads)
  dup . ." bad pages, "
  if
    ." retry " 0
  else
    ." done!" cr 1
    ." Reboot with SW1+SW3 "
  then
;

: upgrade
  ." Hit 'E' to erase, any    other key to upgrade."
  key asc E = if preErase
  else 0
  then
  begin
  0= while
    packet 7 + ic@ +tape>
    ic@ kFigFirmware = if
	  flPages 0 do
	    i tapeBlk>
	  loop
      here 512 allot chkPgs
      0 packet .goodPackets + i!
      0 -tape cls upgradeEnd
    else
      0 -tape cls
      ." Missing Firmware." 0
    then
    key asc q = or
 repeat
 [ find flPages ] literal dup @ current ! dp !
;

upgrade
